// The module 'vscode' contains the VS Code extensibility API
// Import the module and reference it with the alias vscode in your code below
import {
	commands,  window, workspace,WorkspaceFolder, ExtensionContext, Uri
} from "vscode";
import { MainPanel } from "./panels/MainPanel";

// this method is called when your extension is activated
// your extension is activated the very first time the command is executed
export function activate(context: ExtensionContext) {

	// Use the console to output diagnostic information (console.log) and errors (console.error)
	// This line of code will only be executed once when your extension is activated
	console.log('Congratulations, your extension "ext1" is now active!');

	// simple pop-up
	function helloHandler() {
		let path: string;
        if (!workspace.workspaceFolders) {
            path = "none";
        } else {
            let root: WorkspaceFolder;
            if (workspace.workspaceFolders.length === 1) {
                root = workspace.workspaceFolders[0];
				path = root.uri.fsPath;
            } else {
                path="count?";
            }  
        }
		window.showInformationMessage('Hello World!' + path);
	}

	function pickHandler(name: string = 'world') {
		window.showInformationMessage('hello', ...['test', 'taco', 'cheeseburger'])
			.then(selection => {
				console.log(selection);
			});
	}

	function debugHandler(name: string = 'world') {
		console.log(`Hello ${name}!!!`);
	}

	async function newDocHandler(name: string = 'world') {
		let what = await window.showInputBox({ placeHolder: 'file say?' });
		if (what) {
			let uri = Uri.parse('file:' + what);
			let doc = await workspace.openTextDocument(uri); // calls back into the provider
			await window.showTextDocument(doc, { preview: false });
		}
	}
	
	const a=commands.registerCommand('ext1.helloWorld', helloHandler);
	const b=commands.registerCommand('ext1.pick', pickHandler);
	const c=commands.registerCommand('ext1.debug', debugHandler);
	const d=commands.registerCommand('ext1.newDoc', newDocHandler);
	const e=commands.registerCommand("ext1.panel", () => {
		MainPanel.render(context.extensionUri);
	  });
	context.subscriptions.push(a,b,c,d,e);

}

// this method is called when your extension is deactivated
export function deactivate(): void { }

// add

